Loading...
Searching...
No Matches
seqan3::qualified< sequence_alphabet_t, quality_alphabet_t > Class Template Reference

Joins an arbitrary alphabet with a quality alphabet. More...

`#include <seqan3/alphabet/quality/qualified.hpp>`

Inheritance diagram for seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >:
[legend]

## Public Types

using | char_type = alphabet_char_t<sequence_alphabet_type>
| Equals the char_type of sequence_alphabet_type.
using | phred_type = alphabet_phred_t<quality_alphabet_type>
| Equals the phred_type of the quality_alphabet_type.
using | quality_alphabet_type = quality_alphabet_t
| Second template parameter as member type.
using | sequence_alphabet_type = sequence_alphabet_t
| First template parameter as member type.

## Public Member Functions

Write functions
constexpr qualified & | assign_char (char_type const c) noexcept
| Assign from a character. This modifies the internal sequence letter.
constexpr qualified & | assign_phred (phred_type const c) noexcept
| Assign from a Phred score value. This modifies the internal quality letter.
Read functions
constexpr phred_type | to_phred () const noexcept
| Return the Phred score value. This reads the internal quality letter.
constexpr char_type | to_char () const noexcept
| Return a character. This reads the internal sequence letter.
constexpr qualified | complement () const noexcept
| Return a qualified where the quality is preserved, but the sequence letter is complemented.
Public Member Functions inherited from seqan3::alphabet_tuple_base< qualified< sequence_alphabet_t, quality_alphabet_t >, sequence_alphabet_t, quality_alphabet_t >
constexpr qualified< sequence_alphabet_t, quality_alphabet_t > & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr | alphabet_tuple_base (component_types... components) noexcept
| Construction from initialiser-list.
constexpr | alphabet_tuple_base (component_type const alph) noexcept
| Construction via a value of one of the components.
constexpr | alphabet_tuple_base (indirect_component_type const alph) noexcept
| Construction via a value of a subtype that is assignable to one of the components.
constexpr qualified< sequence_alphabet_t, quality_alphabet_t > & | operator= (component_type const alph) noexcept
| Assignment via a value of one of the components.
constexpr qualified< sequence_alphabet_t, quality_alphabet_t > & | operator= (indirect_component_type const alph) noexcept
| Assignment via a value of a subtype that is assignable to one of the components.
constexpr | operator type () const noexcept
| Implicit cast to a single letter. Works only if the type is unique in the type list.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char_t >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Static Public Member Functions

static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character is valid in the sequence alphabet.

## Related Symbols

(Note that these are not member symbols.)
template<typename sequence_alphabet_type, typename quality_alphabet_type>
| qualified (sequence_alphabet_type &&, quality_alphabet_type &&) -> qualified< std::decay_t< sequence_alphabet_type >, std::decay_t< quality_alphabet_type > >
| Type deduction guide enables usage of qualified without specifying template args.

## Constructors, destructor and assignment

constexpr | qualified () noexcept=default
| Defaulted.
constexpr | qualified (qualified const &) noexcept=default
| Defaulted.
constexpr | qualified (qualified &&) noexcept=default
| Defaulted.
constexpr qualified & | operator= (qualified const &) noexcept=default
| Defaulted.
constexpr qualified & | operator= (qualified &&) noexcept=default
| Defaulted.
| ~qualified () noexcept=default
| Defaulted.
constexpr | qualified (component_type const alph) noexcept
| Construction via a value of one of the components.
constexpr | qualified (indirect_component_type const alph) noexcept
| Construction via a value of a subtype that is assignable to one of the components.
constexpr qualified & | operator= (component_type const alph) noexcept
| Assignment via a value of one of the components.
constexpr qualified & | operator= (indirect_component_type const alph) noexcept
| Assignment via a value of a subtype that is assignable to one of the components.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.

## Additional Inherited Members

Static Public Attributes inherited from seqan3::alphabet_tuple_base< qualified< sequence_alphabet_t, quality_alphabet_t >, sequence_alphabet_t, quality_alphabet_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char_t >
static constexpr detail::min_viable_uint_t< size > | alphabet_size = size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< derived_type, size, char_t >
using | char_type = std::conditional_t<std::same_as<char_t, void>, char, char_t>
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type = detail::min_viable_uint_t<size - 1>
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>
class seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >

Joins an arbitrary alphabet with a quality alphabet.

Template Parameters

  sequence_alphabet_t | Type of the alphabet; must satisfy seqan3::writable_alphabet.
  quality_alphabet_t | Type of the quality; must satisfy seqan3::writable_quality_alphabet.

This composite pairs an arbitrary alphabet with a quality alphabet, where each alphabet character is stored together with its quality score in a single value. That way, you can can conveniently access the character and score information at each position of the qualified-sequence. The use case that this was designed for is a nucleotide sequence with corresponding quality scores, e.g. obtained when reading in a FASTQ file of Illumina reads. The composite also allows to store quality scores for different or extended alphabets like a qualified<char, phred42> or a qualified<gapped<dna4>, phred42> sequence. The rank values correspond to numeric values in the size of the composite, while the character values are taken from the sequence alphabet and the Phred score values are taken from the quality alphabet.

As with all seqan3::alphabet_tuple_base s you may access the individual alphabet letters in regular c++ tuple notation, i.e. get<0>(t) and objects can be brace-initialised with the individual members.

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/quality/phred42.hpp>
#include <seqan3/alphabet/quality/qualified.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
using seqan3::get;
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter{'A'_dna4, '('_phred42};
seqan3::debug_stream << seqan3::to_rank(letter) << ' ' // 7
<< seqan3::to_rank(get<0>(letter)) << ' ' // 0
<< seqan3::to_rank(get<1>(letter)) << '\n'; // 7
seqan3::debug_stream << seqan3::to_char(letter) << ' ' // A
<< seqan3::to_char(get<0>(letter)) << ' ' // A
<< seqan3::to_char(get<1>(letter)) << '\n'; // (
seqan3::debug_stream << seqan3::to_phred(letter) << ' ' // 7
<< seqan3::to_phred(get<1>(letter)) << '\n'; // 7
// Modify:
get<0>(letter) = 'G'_dna4;
seqan3::debug_stream << seqan3::to_char(letter) << '\n'; // G
}
seqan3::qualified
Joins an arbitrary alphabet with a quality alphabet.
Definition qualified.hpp:59
debug_stream.hpp
Provides seqan3::debug_stream and related types.
dna4.hpp
Provides seqan3::dna4, container aliases and string literals.
seqan3::to_char
constexpr auto to_char
Return the char representation of an alphabet object.
Definition alphabet/concept.hpp:381
seqan3::to_rank
constexpr auto to_rank
Return the rank representation of a (semi-)alphabet object.
Definition alphabet/concept.hpp:152
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.
seqan3::to_phred
constexpr auto to_phred
The public getter function for the Phred representation of a quality score.
Definition alphabet/quality/concept.hpp:97
seqan3::get
constexpr auto const & get(configuration< configs_t... > const &config) noexcept
This is an overloaded member function, provided for convenience. It differs from the above function o...
Definition configuration.hpp:412
phred42.hpp
Provides seqan3::phred42 quality scores.
qualified.hpp
Provides quality alphabet composites.

This seqan3::alphabet_tuple_base itself fulfils both seqan3::writable_alphabet and seqan3::writable_quality_alphabet.

This entity is stable. Since version 3.1.

## Member Typedef Documentation

## char_type

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

using seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::char_type = alphabet_char_t<sequence_alphabet_type>

Equals the char_type of sequence_alphabet_type.

This entity is stable. Since version 3.1.

## phred_type

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

using seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::phred_type = alphabet_phred_t<quality_alphabet_type>

Equals the phred_type of the quality_alphabet_type.

This entity is stable. Since version 3.1.

## quality_alphabet_type

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

using seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::quality_alphabet_type = quality_alphabet_t

Second template parameter as member type.

This entity is stable. Since version 3.1.

## sequence_alphabet_type

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

using seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::sequence_alphabet_type = sequence_alphabet_t

First template parameter as member type.

This entity is stable. Since version 3.1.

## Constructor & Destructor Documentation

## qualified() [1/2]

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::qualified | ( | component_type const | alph | ) |

inline constexpr noexcept

Construction via a value of one of the components.

Template Parameters

  component_type | Must be one uniquely contained in the type list of the composite.

Parameters

  alph | The value of a component that should be assigned.

Note: Since the alphabet_tuple_base is a CRTP base class, we show the working examples with one of its derived classes (seqan3::qualified).

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/quality/phred42.hpp>
#include <seqan3/alphabet/quality/qualified.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter1{'C'_dna4}; // creates {'C'_dna4, '!'_phred42}
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter2{'"'_phred42}; // creates {'A'_dna4, '"'_phred42}
if (letter1 == letter2)
seqan3::debug_stream << "yeah\n"; // yeah
}

This entity is stable. Since version 3.1.

## qualified() [2/2]

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::qualified | ( | indirect_component_type const | alph | ) |

inline constexpr noexcept

Construction via a value of a subtype that is assignable to one of the components.

Template Parameters

  indirect_component_type | Type that models seqan3::weakly_assignable_from for one of the component types.

Parameters

  alph | The value that should be assigned.

Note that the value will be assigned to the FIRST type T that fulfils assignable_from<T, indirect_component_type>, regardless if other types are also fit for assignment.

Note: Since the alphabet_tuple_base is a CRTP base class, we show the working examples with one of its derived classes (seqan3::qualified).

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/all.hpp>
#include <seqan3/alphabet/quality/phred42.hpp>
#include <seqan3/alphabet/quality/qualified.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
// The following creates {'C'_dna4, '!'_phred42}
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter1{'C'_dna4};
// The following also creates {'C'_dna4, '!'_phred42}, since rna4 assignable to dna4
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter2{'C'_rna4};
if (letter1 == letter2)
seqan3::debug_stream << "yeah\n"; // yeah
}
all.hpp
Meta-header for the Alphabet / Nucleotide submodule .

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Member Function Documentation

## assign_char()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

qualified & seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::assign_char | ( | char_type const | c | ) |

inline constexpr noexcept

Assign from a character. This modifies the internal sequence letter.

This entity is stable. Since version 3.1.

## assign_phred()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

qualified & seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::assign_phred | ( | phred_type const | c | ) |

inline constexpr noexcept

Assign from a Phred score value. This modifies the internal quality letter.

This entity is stable. Since version 3.1.

## char_is_valid()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

constexpr bool seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::char_is_valid | ( | char_type const | c | ) |

inline static constexpr noexcept

Validate whether a character is valid in the sequence alphabet.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## complement()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

qualified seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::complement | ( |  | ) | const

inline constexpr noexcept

Return a qualified where the quality is preserved, but the sequence letter is complemented.

See also
  seqan3::complement
  seqan3::nucleotide

This entity is stable. Since version 3.1.

## operator=() [1/2]

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

qualified & seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::operator= | ( | component_type const | alph | ) |

inline constexpr noexcept

Assignment via a value of one of the components.

Template Parameters

  component_type | One of the component types. Must be uniquely contained in the type list of the composite.

Parameters

  alph | The value of a component that should be assigned.

Note: Since the alphabet_tuple_base is a CRTP base class, we show the working examples with one of its derived classes (seqan3::qualified).

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/dna4.hpp>
#include <seqan3/alphabet/quality/phred42.hpp>
#include <seqan3/alphabet/quality/qualified.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter1{'T'_dna4, '"'_phred42};
letter1 = 'C'_dna4; // yields {'C'_dna4, '"'_phred42}
letter1 = '#'_phred42; // yields {'C'_dna4, '#'_phred42}
}

This entity is stable. Since version 3.1.

## operator=() [2/2]

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

qualified & seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::operator= | ( | indirect_component_type const | alph | ) |

inline constexpr noexcept

Assignment via a value of a subtype that is assignable to one of the components.

Template Parameters

  indirect_component_type | Type that models seqan3::weakly_assignable_from for one of the component types.

Parameters

  alph | The value of a component that should be assigned.

Note: Since the alphabet_tuple_base is a CRTP base class, we show the working examples with one of its derived classes (seqan3::qualified).

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/nucleotide/all.hpp>
#include <seqan3/alphabet/quality/phred42.hpp>
#include <seqan3/alphabet/quality/qualified.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::qualified<seqan3::dna4, seqan3::phred42> letter1{'T'_dna4, '"'_phred42};
letter1 = 'C'_rna4; // yields {'C'_dna4, '"'_phred42}
}

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## to_char()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

char_type seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::to_char | ( |  | ) | const

inline constexpr noexcept

Return a character. This reads the internal sequence letter.

This entity is stable. Since version 3.1.

## to_phred()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

phred_type seqan3::qualified< sequence_alphabet_t, quality_alphabet_t >::to_phred | ( |  | ) | const

inline constexpr noexcept

Return the Phred score value. This reads the internal quality letter.

This entity is stable. Since version 3.1.

## to_rank()

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

| ( |  | ) | const

Return the letter's numeric value (rank in the alphabet).

Provides an implementation for seqan3::to_rank, required to model seqan3::semialphabet.

### Complexity

Constant.

### Exceptions

Guaranteed not to throw.

This entity is stable. Since version 3.1.

## Member Data Documentation

## alphabet_size

template<writable_alphabet sequence_alphabet_t, writable_quality_alphabet quality_alphabet_t>

static

The size of the alphabet, i.e. the number of different values it can take.

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- qualified.hpp

Hide me